package it.inaf.oats.ia2.tap.tsm.ejb;

import it.inaf.oats.ia2.tap.tsm.TSMPages;
import it.inaf.oats.ia2.tap.tsm.model.Credentials;
import it.inaf.oats.ia2.tap.tsm.model.SelectTapSchemaModel;
import it.inaf.oats.ia2.tap.tsm.rest.EditTapSchemaPageState;
import javax.annotation.PostConstruct;
import javax.ejb.Stateful;

/**
 *
 * @author Sonia Zorba <zorba at oats.inaf.it>
 */
@Stateful
public class ApplicationManager implements ApplicationManagerLocal {

    String currentPage;

    private boolean isLoggedIn;

    private Credentials credentials;
    private SelectTapSchemaModel selectTapSchemaModel;
    private EditTapSchemaPageState editTapSchemaPageState;

    @PostConstruct
    public void init() {
        credentials = new Credentials();
        currentPage = TSMPages.CREDENTIALS;
        isLoggedIn = false;
        selectTapSchemaModel = null;
        editTapSchemaPageState = null;
    }

    @Override
    public boolean isLoggedIn() {
        return isLoggedIn;
    }

    @Override
    public Credentials getCredentials() {
        return this.credentials;
    }

    @Override
    public SelectTapSchemaModel getSelectTapSchema() {
        return this.selectTapSchemaModel;
    }

    @Override
    public void setSelectTapSchemaModel(SelectTapSchemaModel selectTapSchemaModel) {
        this.selectTapSchemaModel = selectTapSchemaModel;
        this.isLoggedIn = true;
    }

    @Override
    public EditTapSchemaPageState getEditTapSchemaPageState() {
        return this.editTapSchemaPageState;
    }

    @Override
    public void setEditTapSchemaPageState(EditTapSchemaPageState editTapSchemaPageState) {
        this.editTapSchemaPageState = editTapSchemaPageState;
    }

    @Override
    public String getCurrentPage() {
        return this.currentPage;
    }

    @Override
    public void setCurrentPage(String pageName) {
        this.currentPage = pageName;

        if (currentPage.equals(TSMPages.CREDENTIALS)) {
            init();
        } else if (currentPage.equals(TSMPages.SELECT_SCHEMA)) {
            editTapSchemaPageState = null;
        }
    }
}
